diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index e989e6a4a..5e06c9c25 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -15,6 +15,7 @@ import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.enums.MobCategory;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.item.tool.ItemToolPickaxe;
@@ -117,7 +118,7 @@ public class DataDumper implements MinecraftAccessor {
                 .append(item.id).append(",")
                 .append(item.getKey()).append(",")
                 .append(item.getMaxDamage()).append(",")
-                .append(item instanceof ItemFood ? ((ItemFood) item).getHealAmount() : "").append(",")
+                .append(item instanceof ItemFood ? ((ItemFood) item).getHealAmount(new ItemStack(item)) : "").append(",")
                 .append(item.getItemStackLimit(null)).append(",")
                 .append("\"").append(translator.translateKey(item.getKey() + ".name")).append("\"").append(",")
                 .append("\"").append(translator.translateKey(item.getKey() + ".desc")).append("\"").append(",");
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 224ca0a73..dcd58660a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -432,7 +432,7 @@ public abstract class ScreenContainerAbstract extends Screen {
                     break;
                 }
             }
-            isFuel = LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0;
+            isFuel = LookupFuelFurnace.instance.getFuelYield(stackInSlot) > 0;
 
             if (isIngredient) {
                 target = 1; // Into the ingredient slot
@@ -453,7 +453,7 @@ public abstract class ScreenContainerAbstract extends Screen {
                     break;
                 }
             }
-            isFuel = LookupFuelFurnaceBlast.instance.getFuelYield(clickedItemId) > 0;
+            isFuel = LookupFuelFurnaceBlast.instance.getFuelYield(stackInSlot) > 0;
 
             if (isIngredient) {
                 target = 1; // Into the ingredient slot
@@ -462,7 +462,7 @@ public abstract class ScreenContainerAbstract extends Screen {
             }
         }
         if (this.inventorySlots instanceof MenuTrommel) {
-            if (LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0) {
+            if (LookupFuelFurnace.instance.getFuelYield(stackInSlot) > 0) {
                 target = 2; // Into the fuel slot
             } else {
                 target = 1; // Into the item slots
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
index e35788124..a30230736 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
@@ -9,11 +9,10 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicEdible;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemFood;
-import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.*;
 import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.phys.HitResult;
+import org.lwjgl.opengl.GL11;
 
 import java.util.Random;
 
@@ -70,106 +69,91 @@ public class HudComponentHealthBar extends HudComponentMovable {
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
-        // Setup rendering
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         GLRenderer.enableState(State.BLEND);
 
         boolean heartsFlash = (mc.thePlayer.heartsFlashTime / 3) % 2 == 1;
-        if (mc.thePlayer.heartsFlashTime < 10) {
+        if (mc.thePlayer.heartsFlashTime < 10)
+        {
             heartsFlash = false;
         }
 
         int health = mc.thePlayer.getHealth();
         int prevHealth = mc.thePlayer.prevHealth;
-        this.random.setSeed(hud.updateCounter * 0x4c627L);
+        random.setSeed(hud.updateCounter * 0x4c627L);
         boolean isHardcore = mc.thePlayer.getGamemode() == Gamemodes.HARDCORE;
 
         boolean isVertical = this.isVertical();
         boolean isFlipped = this.isFlipped();
-        
+
         String styleFolder = isHardcore ? "hardcore/" : "survival/";
-        
-        String halfSuffix = "";
-        if (isVertical) {
-            halfSuffix = isFlipped ? "_vertical_flipped" : "_vertical";
-        } else if (isFlipped) {
-            halfSuffix = "_flipped";
-        }
+        String halfSuffix = isVertical ? (isFlipped ? "_vertical_flipped" : "_vertical") : (isFlipped ? "_flipped" : "");
 
         for (int i = 0; i < 10; i++) {
-            int heartOffset = 0;
-            if (heartsFlash) {
-                heartOffset = 1;
-            }
+            int heartOffset = heartsFlash ? 1 : 0;
+            int xHeart = x;
+            int yHeart = y;
 
-            int xHeart;
-            int yHeart;
-
-            // Coordinate logic applying both vertical and flipped states
             if (isVertical) {
-                xHeart = x;
-                yHeart = isFlipped ? (y + i * 8) : (y + (9 - i) * 8); 
-                if (health <= 4) {
-                    xHeart += this.random.nextInt(2);  // Shake horizontally
-                }
+                yHeart = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+                if (health <= 4) xHeart += this.random.nextInt(2);
             } else {
-                xHeart = isFlipped ? (x + (9 - i) * 8) : (x + i * 8); 
-                yHeart = y;
-                if (health <= 4) {
-                    yHeart += this.random.nextInt(2); // Shake vertically
-                }
+                xHeart = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                if (health <= 4) yHeart += random.nextInt(2);
             }
-            
-            hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
 
-            // Flashing Damage/Heal Overlay
+            hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ?
+                    TextureRegistry.getTexture("minecraft:gui/hud/heart/container") :
+                    TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
+
             if (heartsFlash) {
                 if (i * 2 + 1 < prevHealth) {
                     hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "full_blinking"));
-                }
-                if (i * 2 + 1 == prevHealth) {
+                } else if (i * 2 + 1 == prevHealth) {
                     hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "half_blinking" + halfSuffix));
                 }
             }
 
-            // Base Health
             if (i * 2 + 1 < health) {
                 hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "full"));
-            }
-            if (i * 2 + 1 == health) {
+            } else if (i * 2 + 1 == health) {
                 hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "half" + halfSuffix));
             }
 
-            // Food Regen Overlay
             if (GameSettings.FOOD_HEALTH_REGEN_OVERLAY.value) {
-                int healing = 0;
-                ItemStack held = mc.thePlayer.getHeldItem();
-                if (held != null) {
-                    Item heldItem = held.getItem();
-                    if (heldItem instanceof ItemFood) {
-                        healing = ((ItemFood) heldItem).getHealAmount();
-                    }
-                }
-                if (mc.objectMouseOver instanceof HitResult.Tile hitTile) {
-                    Block<?> b = mc.currentWorld.getBlockType(hitTile.tilePos);
-                    if (Block.getLogicClass(b) instanceof BlockLogicEdible edible) {
-                        healing = edible.getHealAmount(mc.currentWorld, hitTile.tilePos);
+                int healing = getPotentialHealing();
+                if (healing > 0 && i * 2 + 1 >= health) {
+                    if (i * 2 + 1 == health) {
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/half_right" + halfSuffix));
+                    } else if (i * 2 + 1 < health + healing) {
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/full"));
+                    } else if (i * 2 + 1 == health + healing) {
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/half" + halfSuffix));
                     }
                 }
+            }
+        }
+        GLRenderer.disableState(State.BLEND);
+    }
 
-                if (healing > 0) {
-                    if (i * 2 + 1 >= health) {
-                        if (i * 2 + 1 == health) {
-                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/half_right" + halfSuffix));
-                        } else if (i * 2 + 1 < health + healing) {
-                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/full"));
-                        } else if (i * 2 + 1 == health + healing) {
-                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/half" + halfSuffix));
-                        }
-                    }
-                }
+    private int getPotentialHealing() {
+        int healing = 0;
+
+        ItemStack held = mc.thePlayer.getHeldItem();
+
+        if (held != null && held.getItem() instanceof ItemFood food) {
+            healing = food.getHealAmount(held);
+        }
+
+        if (mc.objectMouseOver instanceof HitResult.Tile hitTile) {
+            Block<?> block = mc.currentWorld.getBlockType(hitTile.tilePos);
+
+            if (Block.getLogicClass(block) instanceof BlockLogicEdible edible) {
+                healing = edible.getHealAmount(mc.currentWorld, hitTile.tilePos);
             }
         }
+
+        return healing;
     }
 
     @Override
@@ -206,10 +190,10 @@ public class HudComponentHealthBar extends HudComponentMovable {
                 yHeart = y;
             }
 
-            // Container 
+            // Container
             gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
-
-            if (i * 2 + 1 < health) {
+            if (i * 2 + 1 < health)
+            {
                 gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "full"));
             }
             if (i * 2 + 1 == health) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 0209477d9..e140ae371 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -31,7 +31,6 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.worldtype.WorldTypeFX;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.WorldClient;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
@@ -1945,9 +1944,59 @@ public class RenderGlobal
             case EVENT_PISTON_RETRACT: // Piston retract
                 this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5F, (double) y + 0.5F, (double) z + 0.5F, "tile.piston.in", 0.5F, this.world.rand.nextFloat() * 0.25F + 0.6F);
                 break;
-            default:
+            case EVENT_CONDUIT_PORT_PARTICLES: // Conduit port open particles
+                Side s1 = unpackEventConduitSide(data);
+                int xO = s1.getOffsetX();
+                int yO = s1.getOffsetY();
+                int zO = s1.getOffsetZ();
+                double xP = (double) x + (double) xO * 0.6D + 0.5D;
+                double yP = (double) y + (double) yO * 0.6D + 0.5D;
+                double zP = (double) z + (double) zO * 0.6D + 0.5D;
+                for (int i = 0; i < 2; i++) {
+                    double rO = random.nextDouble() * 0.2D + 0.01D;
+                    double fx = xP + (double) xO * 0.01D + (random.nextDouble() - 0.5D) * (double) zO * 0.5D;
+                    double fy = yP + (double) yO * 0.01D + (random.nextDouble() - 0.5D) * (double) yO * 0.5D;
+                    double fz = zP + (double) zO * 0.01D + (random.nextDouble() - 0.5D) * (double) xO * 0.5D;
+                    double mx = (double) xO * rO;
+                    double my = (double) yO * rO;
+                    double mz = (double) zO * rO;
+                    addParticle("reddust", fx, fy, fz, mx, my, mz, unpackEventConduitStrength(data), false);
+                }
+
                 break;
+            case EVENT_CONDUIT_SURFACE_PARTICLES: //conduit ambient particles
+                int surfaceStrength = unpackEventConduitStrength(data);
+
+                if (surfaceStrength <= 0) {
+                    break;
+                }
+
+                double d = 0.0625;
+
+                Direction dir = Direction.directions[random.nextInt(Direction.directions.length)];
+
+                double lx = (double) x + random.nextFloat();
+                double ly = (double) y + random.nextFloat();
+                double lz = (double) z + random.nextFloat();
+
+                if (!this.world.isBlockOpaqueCube(x + dir.getOffsetX(), y + dir.getOffsetY(), z + dir.getOffsetZ())) {
+                    switch (dir) {
+                        case UP -> ly = (y + 1) + d;
+                        case DOWN -> ly = (y) - d;
+                        case SOUTH -> lz = (z + 1) + d;
+                        case NORTH -> lz = (z) - d;
+                        case EAST -> lx = (x + 1) + d;
+                        case WEST -> lx = (x) - d;
+                    }
+                }
+
+                if (lx < x || lx > (x + 1) || ly < 0.0D || ly > (y + 1) || lz < z || lz > (z + 1)) {
+                    addParticle("reddust", lx, ly, lz, 0, 0, 0, surfaceStrength, false);
+                }
 
+                break;
+            default:
+                break;
         }
     }
 
@@ -1959,4 +2008,13 @@ public class RenderGlobal
     public void entityRemoved(Entity entity) {
     }
 
+    public static Side unpackEventConduitSide(int packed) {
+        int sideId = (packed >> 4) & 0x07;
+        return Side.getSideById(sideId);
+    }
+
+    public static int unpackEventConduitStrength(int packed) {
+        return packed & 0x0F;
+    }
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index 84a74fbc6..235f6d164 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -62,6 +62,7 @@ public final class TileEntityRenderDispatcher {
     }
 
     @SuppressWarnings("unchecked") // trust me this is safe, Notch did it first
+    // Instills me with much confidence :wolfblock: ^
     public <T extends TileEntity> TileEntityRenderer<T> getRenderer(final Class<? extends TileEntity> e) {
         TileEntityRenderer<? extends TileEntity> r = this.renderers.get(e);
         if (r == null && e != TileEntity.class) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 14f8493b7..023ec10ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -48,6 +48,7 @@ public final class BlockColorDispatcher
         addDispatch(Blocks.WIRE_REDSTONE, new BlockColorWireRedstone());
         addDispatch(Blocks.TALLGRASS, new BlockColorCustom(Colorizers.grass));
         addDispatch(Blocks.TALLGRASS_FERN, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Blocks.RUBYGLASS_CONDUIT, new BlockColorRubyglassConduit());
     }
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorRubyglassConduit.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorRubyglassConduit.java
new file mode 100644
index 000000000..679cad0ca
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorRubyglassConduit.java
@@ -0,0 +1,63 @@
+package net.minecraft.client.render.block.color;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.block.BlockLogicRubyglassConduit;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+
+import javax.imageio.ImageIO;
+import java.awt.image.BufferedImage;
+import java.io.InputStream;
+
+public class BlockColorRubyglassConduit extends BlockColor {
+
+    private static final org.slf4j.Logger LOGGER = LogUtils.getLogger();
+    private final int[] powerColors = new int[11];
+
+    public BlockColorRubyglassConduit() {
+        loadPalette();
+    }
+
+    private void loadPalette() {
+        boolean loadedSuccessfully = false;
+        String palettePath = "/assets/minecraft/textures/misc/colors_conduit.png";
+
+        try (InputStream stream = Minecraft.getMinecraft().texturePackList.getResourceAsStream(palettePath)) {
+            if (stream != null) {
+                BufferedImage image = ImageIO.read(stream);
+
+                for (int i = 0; i < 11; i++) {
+                    int x = Math.min(i, image.getWidth() - 1);
+                    powerColors[i] = image.getRGB(x, 0) & 0xFFFFFF;
+                }
+                loadedSuccessfully = true;
+            }
+        } catch (Exception e) {
+            LOGGER.error("Failed to load conduit palette at {}", palettePath, e);
+        }
+
+        if (!loadedSuccessfully) {
+            powerColors[0] = 0x330000;
+            int minRed = 80;
+            int maxRed = 255;
+            for (int strength = 1; strength <= 10; strength++) {
+                int redValue = minRed + (int)(((strength - 1) / 9.0f) * (maxRed - minRed));
+                powerColors[strength] = (redValue << 16);
+            }
+        }
+    }
+
+    @Override
+    public int getFallbackColor(int meta, int tintIndex) {
+        return powerColors[0];
+    }
+
+    @Override
+    public int getWorldColor(WorldSource world, TilePosc pos, int tintIndex) {
+        int data = world.getBlockData(pos);
+        int strength = data / BlockLogicRubyglassConduit.STATE_COUNT;
+        strength = Math.max(0, Math.min(10, strength));
+        return powerColors[strength];
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index d451b9d60..af8a9e2a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -7,7 +7,6 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
@@ -348,7 +347,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_NODE, loadDataModel("minecraft:block/rubyglass/node")));
         addDispatch(new BlockModelGeneric<>(Blocks.BLOCK_RUBYGLASS, loadDataModel("minecraft:block/rubyglass/block")).forceCullSelf(true));
         addDispatch(new BlockModelCrystalBud<>(Blocks.RUBYGLASS_SPROUT, loadDataModel("minecraft:block/rubyglass/sprout")).render3D(false));
-        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_CIRCUIT, loadDataModel("minecraft:block/rubyglass/circuit")));
+        addDispatch(new BlockModelRubyglassConduit<>(Blocks.RUBYGLASS_CONDUIT));
 
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_NETHERCOAL_NETHERRACK, loadDataModel("minecraft:block/ore/nethercoal/netherrack")));
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_NETHERCOAL_BASALT, loadDataModel("minecraft:block/ore/nethercoal/basalt")));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRubyglassConduit.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRubyglassConduit.java
new file mode 100644
index 000000000..5faddc642
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRubyglassConduit.java
@@ -0,0 +1,101 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.block.model.generic.BlockModelGeneric;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicRubyglassConduit;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelRubyglassConduit<T extends BlockLogicRubyglassConduit> extends BlockModelGeneric<T> {
+
+    private record ModelState(StaticBlockModel model, int rotX, int rotY, int rotZ) { }
+
+    private final ModelState[] stateMapOn = new ModelState[BlockLogicRubyglassConduit.STATE_COUNT];
+    private final ModelState[] stateMapOff = new ModelState[BlockLogicRubyglassConduit.STATE_COUNT];
+
+    public BlockModelRubyglassConduit(Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_core").asModel());
+
+        StaticBlockModel onCore = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_core").asModel();
+        StaticBlockModel onCap = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_cap").asModel();
+        StaticBlockModel onStraight = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_straight").asModel();
+        StaticBlockModel onCorner = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_corner").asModel();
+
+        StaticBlockModel offCore = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_core_off").asModel();
+        StaticBlockModel offCap = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_cap_off").asModel();
+        StaticBlockModel offStraight = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_straight_off").asModel();
+        StaticBlockModel offCorner = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_corner_off").asModel();
+
+        populateStateMap(stateMapOn, onCore, onCap, onStraight, onCorner);
+        populateStateMap(stateMapOff, offCore, offCap, offStraight, offCorner);
+    }
+
+    private void populateStateMap(ModelState[] map, StaticBlockModel core, StaticBlockModel cap, StaticBlockModel straight, StaticBlockModel corner) {
+        // 0: Core
+        map[0] = new ModelState(core, 0, 0, 0);
+
+        // 1-6: End Caps
+        map[1] = new ModelState(cap, 0, 0, 0);
+        map[2] = new ModelState(cap, 2, 0, 0);
+        map[3] = new ModelState(cap, 1, 0, 0);
+        map[4] = new ModelState(cap, 3, 0, 0);
+        map[5] = new ModelState(cap, 0, 0, 3);
+        map[6] = new ModelState(cap, 0, 0, 1);
+
+        // 7-9: Straights
+        map[7] = new ModelState(straight, 0, 0, 0);
+        map[8] = new ModelState(straight, 1, 0, 0);
+        map[9] = new ModelState(straight, 0, 0, 1);
+
+        // 10-13: Bottom Corners
+        map[10] = new ModelState(corner, 0, 0, 0);
+        map[11] = new ModelState(corner, 0, 2, 0);
+        map[12] = new ModelState(corner, 0, 1, 0);
+        map[13] = new ModelState(corner, 0, 3, 0);
+
+        // 14-17: Top Corners
+        map[14] = new ModelState(corner, 2, 2, 0);
+        map[15] = new ModelState(corner, 2, 0, 0);
+        map[16] = new ModelState(corner, 2, 3, 0);
+        map[17] = new ModelState(corner, 2, 1, 0);
+
+        // 18-21: Horizontal Corners
+        map[18] = new ModelState(corner, 0, 0, 3);
+        map[19] = new ModelState(corner, 0, 0, 1);
+        map[20] = new ModelState(corner, 0, 2, 3);
+        map[21] = new ModelState(corner, 0, 2, 1);
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int state = data % BlockLogicRubyglassConduit.STATE_COUNT;
+        int strength = data / BlockLogicRubyglassConduit.STATE_COUNT;
+
+        if (strength == 0) {
+            return stateMapOff[state].model;
+        } else {
+            return stateMapOn[state].model;
+        }
+    }
+
+    @Override
+    public boolean renderAttached(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, final @Nullable IconCoordinate overrideTexture) {
+        int data = worldSource.getBlockData(tilePos);
+        int state = data % BlockLogicRubyglassConduit.STATE_COUNT;
+        int strength = data / BlockLogicRubyglassConduit.STATE_COUNT;
+
+        ModelState activeState;
+        if (strength == 0) {
+            activeState = stateMapOff[state];
+        } else {
+            activeState = stateMapOn[state];
+        }
+
+        return activeState.model.renderAttached(this, tessellator, worldSource, tilePos, activeState.rotX, activeState.rotY, activeState.rotZ, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
\ No newline at end of file
